package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECOUNTRY*/
@Entity(name="TgeneCountry")
@Table(name="TGENECOUNTRY")
public class TgeneCountry extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneCountry
*/
@Id
@Column(name="COUNTRYCODE" ,nullable=false, updatable=false)
private String pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="INITIALS", nullable=true)

/**
* Siglas del pais
*/
private String initials;

@Column(name="AREACODE", nullable=true)

/**
* Codigo de area del pais 
*/
private Integer areacode;

@Column(name="DESCRIPTION", nullable=false)

/**
* Nombre del pais
*/
private String description;

@Column(name="CITIZENSHIP", nullable=false)

/**
* Nacionalidad asociada al pais
*/
private String citizenship;

/**Contructor por defecto*/
public TgeneCountry(){
}
/**Contructor de TgeneCountry
@param pPk Clave Primaria del entity
@param pDescription Nombre del pais
@param pCitizenship Nacionalidad asociada al pais
*/
public TgeneCountry(String pPk,String pDescription,String pCitizenship){
 this();
 pk=pPk;
 description=pDescription;
 citizenship=pCitizenship;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneCountry
*/
public static TgeneCountry find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneCountry obj = pEntityManager.find(TgeneCountry.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneCountry
@return El objeto que referencia a la Clave primaria de TgeneCountry
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneCountry
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneCountry
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de initials
@return valor de initials*/
public String getInitials(){
  return initials;
}
/**Fija el valor de initials
@param pInitials nuevo Valor de initials*/
public void setInitials(String pInitials){
  initials=pInitials;
}

/**Obtiene el valor de areacode
@return valor de areacode*/
public Integer getAreacode(){
  return areacode;
}
/**Fija el valor de areacode
@param pAreacode nuevo Valor de areacode*/
public void setAreacode(Integer pAreacode){
  areacode=pAreacode;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de citizenship
@return valor de citizenship*/
public String getCitizenship(){
  return citizenship;
}
/**Fija el valor de citizenship
@param pCitizenship nuevo Valor de citizenship*/
public void setCitizenship(String pCitizenship){
  citizenship=pCitizenship;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneCountry))return false;
    TgeneCountry that = (TgeneCountry) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneCountry
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneCountry
*/
public Object createInstance(){
 TgeneCountry instance=new TgeneCountry();	
 return instance;
}
/**Clona la entidad TgeneCountry
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneCountry p=(TgeneCountry)this.clone();
  return p;
}
}
